'''client server packet generator'''
import json
import logging
import drivers
from generator_generic import GeneratorGeneric

logger = logging.getLogger(__name__)

def byteify(input): 
    if isinstance(input, dict):     
        return dict([(byteify(key), byteify(value)) for key,
         value in list(input.items())])
    elif isinstance(input, list):   
        return [byteify(element) for element in input]   
    elif isinstance(input, str):
        return input.encode('utf-8')
    else:
        return input    

class Igeneratordriver():
    def __init__(self, allappmodels, allusessions, driver, client, outdir, modeltype='Generic'):
        self.allappmodels = byteify(json.load(open(allappmodels)))
        self.allusessions = byteify(json.load(open(allusessions)))
        self.allusessions.sort(key=lambda v: v['start'])
        self.driver = driver
        self.client = client
        self.outdir = outdir
        self.modeltype = modeltype.capitalize()

    def generate(self):

        mdriverfile = getattr(drivers, self.driver)
        mdriverclass = getattr(mdriverfile, self.driver.capitalize())
        mdriverclass(self.allappmodels, self.allusessions, self.outdir, self.client, modeltype=self.modeltype).generate()
